/*-
 * Copyright (c) 2000
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#include<stdlib.h>
#include<sys/bios.h>


#include"soari.h"

static hero_t Hero;
static int Damage_table[256];

static map_t Map;
static ene_t Ene[NUM_ENE];

static unsigned char Map_buf[MAP_WIDTH*MAP_HEIGHT];

int main( int ac, char **av )
{
	int mode;
	unsigned score,hiscore;
	static int level;

	unsigned long seed;
	seed = sys_get_tick_count();
	srand(seed & 0xffff);

	init_disp();

	Map.map = Map_buf;
	Map.width = MAP_WIDTH;
	Map.height = MAP_HEIGHT;
	Map.prob_floor = 90;

	Hero.damage_table = Damage_table;

	mode = 0;
	level = 1;
	score = 0;
	hiscore = 0;

	for(;;){
		mode = title(mode,score,hiscore,level);
		if( mode == 2 )
			break;
		if( mode == 0 )
			level = 1;

		fade_out();
		score = game(&level,&Map,&Hero,Ene,NUM_ENE);
		if( score > hiscore )
			hiscore = score;
		mode = 1;
	}
	return 0;
}
